// DlgTest.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "DlgTest.h"
#include "math.h"

#include "New VC Classes\series.h"
#include "New VC Classes\Panel.h"
#include "New VC Classes\Gradient.h"
#include "New VC Classes\Canvas.h"
#include "New VC Classes\Tools.h"
#include "New VC Classes\ToolList.h"
#include "New VC Classes\TeeChartDefines.h"
#include "New VC Classes\Page.h"
#include "New VC Classes\shapeseries.h"
#include "New VC Classes\colorgridseries.h"
#include "New VC Classes\pen.h"
#include "New VC Classes\axis.h"
#include "New VC Classes\axes.h"
#include "New VC Classes\cursortool.h"
#include "New VC Classes\gridtransposetool.h"
#include "New VC Classes\areaseries.h"
#include "New VC Classes\surfaceseries.h"
#include "New VC Classes\aspect.h"
#include "New VC Classes\teeopengl.h"


// CDlgTest dialog

IMPLEMENT_DYNCREATE(CDlgTest, CDHtmlDialog)

CDlgTest::CDlgTest(CWnd* pParent /*=NULL*/)
	: CDHtmlDialog(CDlgTest::IDD, CDlgTest::IDH, pParent)
{

}

CDlgTest::~CDlgTest()
{
}

void CDlgTest::DoDataExchange(CDataExchange* pDX)
{
    CDHtmlDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_TCHART1, m_colorGrid);
}

BOOL CDlgTest::OnInitDialog()
{
	CDHtmlDialog::OnInitDialog();
    m_colorGrid.GetTools().Add(tcGridTranspose);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

BEGIN_MESSAGE_MAP(CDlgTest, CDHtmlDialog)
    ON_BN_CLICKED(IDC_BTN_PLOT, &CDlgTest::OnBnClickedBtnPlot)
    ON_WM_TIMER()
    ON_BN_CLICKED(IDC_BTN_PLOT3D, &CDlgTest::OnBnClickedBtnPlot3d)
    ON_BN_CLICKED(IDC_BTN_PLOT_PALETTE, &CDlgTest::OnBnClickedBtnPlotPalette)
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CDlgTest)

END_DHTML_EVENT_MAP()



// CDlgTest message handlers



void CDlgTest::OnBnClickedBtnPlot()
{
  /*     COleSafeArray plotData;

    m_colorGrid.AddSeries(scColorGrid);
   
       
    m_colorGrid.Series(0).GetAsColorGrid().GetPen().SetVisible(FALSE);
    m_colorGrid.Series(0).GetAsColorGrid().SetStartColor(RGB(0,0,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetMidColor(RGB(0,128,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetEndColor(RGB(0,255,0));
   
    DWORD numPoints = 160000;
    plotData.Create(VT_R8, 1, &numPoints); // Create the y-axis safe array 

   //  long i;
   //  i = 0;
    for(long i = 0; i < numPoints; i++) { 
      //  plotData.PutElement(&i, (double *)(&i));
        double val = i;      
        plotData.PutElement(&i, &(val));
    }

    m_colorGrid.Series(0).GetAsColorGrid().AddArrayGrid(400, 399, plotData); // Add the array grid 
    */

   // m_colorGrid.GetAspect().GetOpenGL().SetActive(TRUE);
   
    SetTimer(1, 50, NULL);
}

void CDlgTest::OnTimer(UINT_PTR nIDEvent)
{
    long xCoord;
    long zCoord;
    double startValue;

    m_colorGrid.RemoveAllSeries();
    DWORD m_numPoints;
    m_numPoints = 25000;
    m_spectrumPlotData.Create(VT_R8, 1, &m_numPoints); // Create the y-axis safe array 

    memcpy(m_spectrumDisplayDataTemp, m_spectrumDisplayData, (sizeof(double) * MAX_DATA_INDEX));

    for(long i=0; i<49; i++) { // Cycle through the rows        
        memcpy(&m_spectrumDisplayData[i*500], &m_spectrumDisplayDataTemp[(i+1)*500],  (sizeof(double) * 500));
    }

    srand(m_randomSeed);
    startValue = (double)rand();
    for(long i=0; i<500; i++) { // Cycle through the rows        
        m_spectrumDisplayData[i + (49 * 500)] = (double)rand(); //startValue + (double)i;
    }
    m_randomSeed = rand();

    for(long i=0; i<25000; i++) { // Cycle through the rows        
        m_spectrumPlotData.PutElement(&i, &m_spectrumDisplayData[i]);
    }

    m_colorGridVariant = m_colorGrid.AddSeries(scColorGrid);


    m_colorGrid.Series(0).GetAsColorGrid().GetPen().SetVisible(FALSE);
    m_colorGrid.Series(0).GetAsColorGrid().SetStartColor(RGB(0,255,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetMidColor(RGB(0,128,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetEndColor(RGB(0,0,0));
 

    xCoord = 50;
    zCoord = 500;

    m_colorGrid.Series(0).GetAsColorGrid().AddArrayGrid((long)xCoord, (long)zCoord, m_spectrumPlotData); // Add the array grid 

   
    m_colorGrid.GetTools().GetItems(0).GetAsGridTranspose().SetSeries(COleVariant(m_colorGridVariant));
    m_colorGrid.GetTools().GetItems(0).GetAsGridTranspose().Transpose();  

     m_colorGrid.Series(0).GetAsColorGrid().SetSmoothBitmap(TRUE);

    CDHtmlDialog::OnTimer(nIDEvent);
}

void CDlgTest::OnBnClickedBtnPlot3d()
{
    long xCoord;
    long zCoord;

    m_colorGrid.AddSeries(scSurface);
    m_colorGrid.Series(0).GetAsSurface().GetPen().SetVisible(FALSE);
    m_colorGrid.Series(0).GetAsSurface().SetStartColor(RGB(255,0,0));
    m_colorGrid.Series(0).GetAsSurface().SetMidColor(RGB(0,255,0));
    m_colorGrid.Series(0).GetAsSurface().SetEndColor(RGB(0,0,255));
  //  m_colorGrid.Series(0).GetAsSurface().SetIrregularGrid(FALSE);
    m_colorGrid.Series(0).GetAsSurface().SetUsePalette(TRUE);
    m_colorGrid.Series(0).GetAsSurface().SetPaletteStyle(psInvGray);

    double tmp;
    for(int X = 0; X < 15; X++) {
        for(int z = 0; z < 15; z++) {
          //   tmp = cos((double)((double)X/10.0)) - sin((double)((double)z/10.0));
            tmp = 10;
            if(X >= 4 && X <= 6 && z >= 4 && z <= 6)  {
                tmp = 100;
            }
            if(X >= 7 && X <= 9 && z >= 7 && z <= 9)  {
                tmp = 75;
            }
            m_colorGrid.Series(0).GetAsSurface().AddXYZ(X, tmp, z, _T(""), clTeeColor);
        }
    } 
}

void CDlgTest::OnBnClickedBtnPlotPalette()
{
    long xCoord;
    long zCoord;
    double startValue;


    m_colorGrid.RemoveAllSeries();
    DWORD m_numPoints;
    m_numPoints = 2000;
    m_palettePlotData.Create(VT_R8, 1, &m_numPoints); // Create the y-axis safe array 


    for(long i=0; i<20; i++) {
        for(long j=0; j<100; j++) { // Cycle through the rows        
            m_paletteDisplayData[(i*100) + j] = j;
        }
    }

    for(long i=0; i<2000; i++) { // Cycle through the rows        
        m_palettePlotData.PutElement(&i, &m_paletteDisplayData[i]);
    }

    m_colorGridVariant = m_colorGrid.AddSeries(scColorGrid);


    m_colorGrid.Series(0).GetAsColorGrid().GetPen().SetVisible(FALSE);
    m_colorGrid.Series(0).GetAsColorGrid().SetStartColor(RGB(0,255,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetMidColor(RGB(0,128,0));
    m_colorGrid.Series(0).GetAsColorGrid().SetEndColor(RGB(0,0,0));
 
 
    xCoord = 20;
    zCoord = 100;

    m_colorGrid.Series(0).GetAsColorGrid().AddArrayGrid((long)xCoord, (long)zCoord, m_palettePlotData); // Add the array grid 

   
    m_colorGrid.GetTools().GetItems(0).GetAsGridTranspose().SetSeries(COleVariant(m_colorGridVariant));
    m_colorGrid.GetTools().GetItems(0).GetAsGridTranspose().Transpose();  

    m_colorGrid.Series(0).GetAsColorGrid().SetSmoothBitmap(TRUE);
}
