#pragma once

#include "New VC Classes\tchart.h"

#ifdef _WIN32_WCE
#error "CDHtmlDialog is not supported for Windows CE."
#endif 

// CDlgTest dialog
// CSpectrumSnapshot dialog
#define MAX_DATA_INDEX 25000
#define PLOT_X_SIZE 500
#define PLOT_Y_SIZE 50

class CDlgTest : public CDHtmlDialog
{
	DECLARE_DYNCREATE(CDlgTest)

public:
	CDlgTest(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDlgTest();

    long m_colorGridVariant;      // Handle to the series variant  
    double m_spectrumDisplayData[MAX_DATA_INDEX]; // Spectrum display data
    double m_spectrumDisplayDataTemp[MAX_DATA_INDEX];
    double m_paletteDisplayData[2000];
    long m_plotXSize;
    long m_plotYSize;
    long m_plotDataPos;
    COleSafeArray m_spectrumPlotData;
    COleSafeArray m_palettePlotData;
    long m_randomSeed;

// Overrides

// Dialog Data
	enum { IDD = IDD_DLG_TEST, IDH = IDR_HTML_DLGTEST };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
	DECLARE_DHTML_EVENT_MAP()
public:
    afx_msg void OnBnClickedBtnPlot();
    CTChart m_colorGrid;
    afx_msg void OnTimer(UINT_PTR nIDEvent);
    afx_msg void OnBnClickedBtnPlot3d();
    afx_msg void OnBnClickedBtnPlotPalette();
};
